CfnWorkforce
- class aws_cdk.aws_sagemaker.CfnWorkforce(scope, id, *, workforce_name, cognito_config=None, ip_address_type=None, oidc_config=None, source_ip_config=None, tags=None, workforce_vpc_config=None)
Bases:
CfnResourceResource Type definition for AWS::SageMaker::Workforce.
Use to create a private workforce that you can use to label your training data using Amazon SageMaker Ground Truth.
- See:
http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sagemaker-workforce.html
- CloudformationResource:
AWS::SageMaker::Workforce
- ExampleMetadata:
fixture=_generated
Example:
from aws_cdk import CfnTag # The code below shows an example of how to instantiate this type. # The values are placeholders you should change. from aws_cdk import aws_sagemaker as sagemaker cfn_workforce = sagemaker.CfnWorkforce(self, "MyCfnWorkforce", workforce_name="workforceName", # the properties below are optional cognito_config=sagemaker.CfnWorkforce.CognitoConfigProperty( client_id="clientId", user_pool="userPool" ), ip_address_type="ipAddressType", oidc_config=sagemaker.CfnWorkforce.OidcConfigProperty( authorization_endpoint="authorizationEndpoint", client_id="clientId", issuer="issuer", jwks_uri="jwksUri", logout_endpoint="logoutEndpoint", token_endpoint="tokenEndpoint", user_info_endpoint="userInfoEndpoint", # the properties below are optional authentication_request_extra_params={ "authentication_request_extra_params_key": "authenticationRequestExtraParams" }, client_secret="clientSecret", scope="scope" ), source_ip_config=sagemaker.CfnWorkforce.SourceIpConfigProperty( cidrs=["cidrs"] ), tags=[CfnTag( key="key", value="value" )], workforce_vpc_config=sagemaker.CfnWorkforce.WorkforceVpcConfigRequestProperty( security_group_ids=["securityGroupIds"], subnets=["subnets"], vpc_id="vpcId" ) )
Create a new
AWS::SageMaker::Workforce.- Parameters:
scope (
Construct) – Scope in which this resource is defined.id (
str) – Construct identifier for this resource (unique in its scope).workforce_name (
str) – The name of the private workforce.cognito_config (
Union[IResolvable,CognitoConfigProperty,Dict[str,Any],None]) – The configuration of an Amazon Cognito workforce. A single Cognito workforce is created using and corresponds to a single Amazon Cognito user pool.ip_address_type (
Optional[str]) – The IP address type for the workforce. IPv4 only or dualstack (IPv4 and IPv6).oidc_config (
Union[IResolvable,OidcConfigProperty,Dict[str,Any],None]) – The configuration of an OIDC Identity Provider (IdP) private workforce.source_ip_config (
Union[IResolvable,SourceIpConfigProperty,Dict[str,Any],None]) – A list of IP address ranges used to access your training data.tags (
Optional[Sequence[Union[CfnTag,Dict[str,Any]]]]) – An array of key-value pairs.workforce_vpc_config (
Union[IResolvable,WorkforceVpcConfigRequestProperty,Dict[str,Any],None]) – The VPC configuration for the workforce.
Methods
- add_deletion_override(path)
Syntactic sugar for
addOverride(path, undefined).- Parameters:
path (
str) – The path of the value to delete.- Return type:
None
- add_dependency(target)
(deprecated) Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
This method has been renamed to
addResourceDependencyto more clearly set it apart fromconstruct.node.addDependency. See the documentation of that function for more details.- Parameters:
target (
CfnResource)- Deprecated:
Use
addResourceDependencyinstead.- Stability:
deprecated
- Return type:
None
- add_depends_on(target)
(deprecated) Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to
addResourceDependency, which makes it more clear that this method operates at a different level from the construct-levelconstruct.node.addDependency()mechanism.- Parameters:
target (
CfnResource)- Deprecated:
Use
addResourceDependencyinstead.- Stability:
deprecated
- Return type:
None
- add_metadata(key, value)
Add a value to the CloudFormation Resource Metadata.
- Parameters:
key (
str)value (
Any)
- See:
- Return type:
None
https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/metadata-section-structure.html
Note that this is a different set of metadata from CDK node metadata; this metadata ends up in the stack template under the resource, whereas CDK node metadata ends up in the Cloud Assembly.
- add_override(path, value)
Adds an override to the synthesized CloudFormation resource.
To add a property override, either use
addPropertyOverrideor prefixpathwith “Properties.” (i.e.Properties.TopicName).If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal
.in the property name, prefix with a\. In most programming languages you will need to write this as"\\."because the\itself will need to be escaped.For example:
cfn_resource.add_override("Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes", ["myattribute"]) cfn_resource.add_override("Properties.GlobalSecondaryIndexes.1.ProjectionType", "INCLUDE")
would add the overrides Example:
"Properties": { "GlobalSecondaryIndexes": [ { "Projection": { "NonKeyAttributes": [ "myattribute" ] ... } ... }, { "ProjectionType": "INCLUDE" ... }, ] ... }
The
valueargument toaddOverridewill not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.- Parameters:
path (
str) –The path of the property, you can use dot notation to override values in complex types. Any intermediate keys will be created as needed.
value (
Any) –The value. Could be primitive or complex.
- Return type:
None
- add_property_deletion_override(property_path)
Adds an override that deletes the value of a property from the resource definition.
- Parameters:
property_path (
str) – The path to the property.- Return type:
None
- add_property_override(property_path, value)
Adds an override to a resource property.
Syntactic sugar for
addOverride("Properties.<...>", value).- Parameters:
property_path (
str) – The path of the property.value (
Any) – The value.
- Return type:
None
- add_resource_dependency(target, reason=None)
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use
construct.node.addDependencyinstead.- Parameters:
target (
CfnResource)reason (
Optional[str])
- Return type:
None
- apply_cross_stack_reference_strength(strength)
Sets the cross-stack reference strength for this resource.
When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack’s context.
- Parameters:
strength (
ReferenceStrength) –The reference strength to use for this resource.
- Return type:
None
- apply_removal_policy(policy=None, *, apply_to_update_replace_policy=None, default=None)
Sets the deletion policy of the resource based on the removal policy specified.
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you’ve removed it from the CDK application or because you’ve made a change that requires the resource to be replaced.
The resource can be deleted (
RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:- Parameters:
policy (
Optional[RemovalPolicy])apply_to_update_replace_policy (
Optional[bool]) – Apply the same deletion policy to the resource’s “UpdateReplacePolicy”. Default: truedefault (
Optional[RemovalPolicy]) – The default policy to apply in case the removal policy is not defined. Default: - Default value is resource specific. To determine the default value for a resource, please consult that specific resource’s documentation.
- See:
- Return type:
None
- cfn_property_name(cdk_property_name)
- Parameters:
cdk_property_name (
str)- Return type:
Optional[str]
- get_att(attribute_name, type_hint=None)
Returns a token for an runtime attribute of this resource.
Ideally, use generated attribute accessors (e.g.
resource.arn), but this can be used for future compatibility in case there is no generated attribute.- Parameters:
attribute_name (
str) – The name of the attribute.type_hint (
Optional[ResolutionTypeHint])
- Return type:
- get_metadata(key)
Retrieve a value value from the CloudFormation Resource Metadata.
- Parameters:
key (
str)- See:
- Return type:
Any
https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/metadata-section-structure.html
Note that this is a different set of metadata from CDK node metadata; this metadata ends up in the stack template under the resource, whereas CDK node metadata ends up in the Cloud Assembly.
- inspect(inspector)
Examines the CloudFormation resource and discloses attributes.
- Parameters:
inspector (
TreeInspector) – tree inspector to collect and process attributes.- Return type:
None
- obtain_dependencies()
Retrieves an array of resources and stacks this resource depends on.
For resources depended on directly, returns the
CfnResourceobject. For dependencies on other stacks, returns theStackobject. The order of the array is not guaranteed.- Return type:
List[Union[Stack,CfnResource]]
- override_logical_id(new_logical_id)
Overrides the auto-generated logical ID with a specific ID.
- Parameters:
new_logical_id (
str) – The new logical ID to use for this stack element.- Return type:
None
- remove_dependency(target)
(deprecated) Indicates that this resource no longer depends on another resource.
This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
- Parameters:
target (
CfnResource)- Deprecated:
Use
removeResourceDependencyinstead- Stability:
deprecated
- Return type:
None
- remove_resource_dependency(target)
Indicates that this resource no longer depends on another resource.
This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
- Parameters:
target (
CfnResource)- Return type:
None
- replace_dependency(target, new_target)
Replaces one dependency with another.
- Parameters:
target (
CfnResource) – The dependency to replace.new_target (
CfnResource) – The new dependency to add.
- Return type:
None
- to_string()
Returns a string representation of this construct.
- Return type:
str- Returns:
a string representation of this resource
- with_(*mixins)
Applies one or more mixins to this construct.
Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple
with()calls if subsequent mixins should apply to added constructs.- Parameters:
mixins (
IMixin)- Return type:
Attributes
- CFN_RESOURCE_TYPE_NAME = 'AWS::SageMaker::Workforce'
- attr_sub_domain
The subdomain for your OIDC Identity Provider.
- CloudformationAttribute:
SubDomain
- attr_workforce_arn
The Amazon Resource Name (ARN) of the private workforce.
- CloudformationAttribute:
WorkforceArn
- cdk_tag_manager
Tag Manager which manages the tags for this resource.
- cfn_options
Options for this resource, such as condition, update policy etc.
- cfn_resource_type
AWS resource type.
- cognito_config
The configuration of an Amazon Cognito workforce.
- creation_stack
return:
the stack trace of the point where this Resource was created from, sourced from the +metadata+ entry typed +aws:cdk:logicalId+, and with the bottom-most node +internal+ entries filtered.
- env
- ip_address_type
The IP address type for the workforce.
- logical_id
The logical ID for this CloudFormation stack element.
The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use
overrideLogicalId(newLogicalId).- Returns:
the logical ID as a stringified token. This value will only get resolved during synthesis.
- node
The tree node.
- oidc_config
The configuration of an OIDC Identity Provider (IdP) private workforce.
- ref
Return a string that will be resolved to a CloudFormation
{ Ref }for this element.If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through
Lazy.any({ produce: resource.ref }).
- source_ip_config
A list of IP address ranges used to access your training data.
- stack
The stack in which this element is defined.
CfnElements must be defined within a stack scope (directly or indirectly).
- tags
An array of key-value pairs.
- workforce_name
The name of the private workforce.
- workforce_ref
A reference to a Workforce resource.
- workforce_vpc_config
The VPC configuration for the workforce.
Static Methods
- classmethod arn_for_workforce(resource)
- Parameters:
resource (
IWorkforceRef)- Return type:
str
- classmethod is_cfn_element(x)
Returns
trueif a construct is a stack element (i.e. part of the synthesized cloudformation template).Uses duck-typing instead of
instanceofto allow stack elements from different versions of this library to be included in the same stack.- Parameters:
x (
Any)- Return type:
bool- Returns:
The construct as a stack element or undefined if it is not a stack element.
- classmethod is_cfn_resource(x)
Check whether the given object is a CfnResource.
- Parameters:
x (
Any)- Return type:
bool
- classmethod is_cfn_workforce(x)
Checks whether the given object is a CfnWorkforce.
- Parameters:
x (
Any)- Return type:
bool
- classmethod is_construct(x)
Checks if
xis a construct.Use this method instead of
instanceofto properly detectConstructinstances, even when the construct library is symlinked.Explanation: in JavaScript, multiple copies of the
constructslibrary on disk are seen as independent, completely different libraries. As a consequence, the classConstructin each copy of theconstructslibrary is seen as a different class, and an instance of one class will not test asinstanceofthe other class.npm installwill not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of theconstructslibrary can be accidentally installed, andinstanceofwill behave unpredictably. It is safest to avoid usinginstanceof, and using this type-testing method instead.- Parameters:
x (
Any) – Any object.- Return type:
bool- Returns:
true if
xis an object created from a class which extendsConstruct.
CognitoConfigProperty
- class CfnWorkforce.CognitoConfigProperty(*, client_id, user_pool)
Bases:
objectThe configuration of an Amazon Cognito workforce.
A single Cognito workforce is created using and corresponds to a single Amazon Cognito user pool.
- Parameters:
client_id (
str) – The client ID for your Amazon Cognito user pool.user_pool (
str) – The ID for your Amazon Cognito user pool.
- See:
- ExampleMetadata:
fixture=_generated
Example:
# The code below shows an example of how to instantiate this type. # The values are placeholders you should change. from aws_cdk import aws_sagemaker as sagemaker cognito_config_property = sagemaker.CfnWorkforce.CognitoConfigProperty( client_id="clientId", user_pool="userPool" )
Attributes
- client_id
The client ID for your Amazon Cognito user pool.
- user_pool
The ID for your Amazon Cognito user pool.
OidcConfigProperty
- class CfnWorkforce.OidcConfigProperty(*, authorization_endpoint, client_id, issuer, jwks_uri, logout_endpoint, token_endpoint, user_info_endpoint, authentication_request_extra_params=None, client_secret=None, scope=None)
Bases:
objectThe configuration of an OIDC Identity Provider (IdP) private workforce.
- Parameters:
authorization_endpoint (
str) – The OIDC IdP authorization endpoint used to configure your private workforce.client_id (
str) – The OIDC IdP client ID used to configure your private workforce.issuer (
str) – The OIDC IdP issuer used to configure your private workforce.jwks_uri (
str) – The OIDC IdP JSON Web Key Set (Jwks) URI used to configure your private workforce.logout_endpoint (
str) – The OIDC IdP logout endpoint used to configure your private workforce.token_endpoint (
str) – The OIDC IdP token endpoint used to configure your private workforce.user_info_endpoint (
str) – The OIDC IdP user info endpoint used to configure your private workforce.authentication_request_extra_params (
Union[IResolvable,Mapping[str,str],None]) – A string to string map of identifiers specific to the custom identity provider (IdP) being used.client_secret (
Optional[str]) – The OIDC IdP client secret used to configure your private workforce.scope (
Optional[str]) – An array of string identifiers used to refer to the specific pieces of user data or claims that the client application wants to access.
- See:
- ExampleMetadata:
fixture=_generated
Example:
# The code below shows an example of how to instantiate this type. # The values are placeholders you should change. from aws_cdk import aws_sagemaker as sagemaker oidc_config_property = sagemaker.CfnWorkforce.OidcConfigProperty( authorization_endpoint="authorizationEndpoint", client_id="clientId", issuer="issuer", jwks_uri="jwksUri", logout_endpoint="logoutEndpoint", token_endpoint="tokenEndpoint", user_info_endpoint="userInfoEndpoint", # the properties below are optional authentication_request_extra_params={ "authentication_request_extra_params_key": "authenticationRequestExtraParams" }, client_secret="clientSecret", scope="scope" )
Attributes
- authentication_request_extra_params
A string to string map of identifiers specific to the custom identity provider (IdP) being used.
- authorization_endpoint
The OIDC IdP authorization endpoint used to configure your private workforce.
- client_id
The OIDC IdP client ID used to configure your private workforce.
- client_secret
The OIDC IdP client secret used to configure your private workforce.
- issuer
The OIDC IdP issuer used to configure your private workforce.
- jwks_uri
The OIDC IdP JSON Web Key Set (Jwks) URI used to configure your private workforce.
- logout_endpoint
The OIDC IdP logout endpoint used to configure your private workforce.
- scope
An array of string identifiers used to refer to the specific pieces of user data or claims that the client application wants to access.
- token_endpoint
The OIDC IdP token endpoint used to configure your private workforce.
- user_info_endpoint
The OIDC IdP user info endpoint used to configure your private workforce.
SourceIpConfigProperty
- class CfnWorkforce.SourceIpConfigProperty(*, cidrs)
Bases:
objectA list of IP address ranges used to access your training data.
- Parameters:
cidrs (
Sequence[str]) – A list of one to ten Classless Inter-Domain Routing (CIDR) values.- See:
- ExampleMetadata:
fixture=_generated
Example:
# The code below shows an example of how to instantiate this type. # The values are placeholders you should change. from aws_cdk import aws_sagemaker as sagemaker source_ip_config_property = sagemaker.CfnWorkforce.SourceIpConfigProperty( cidrs=["cidrs"] )
Attributes
- cidrs
A list of one to ten Classless Inter-Domain Routing (CIDR) values.
WorkforceVpcConfigRequestProperty
- class CfnWorkforce.WorkforceVpcConfigRequestProperty(*, security_group_ids=None, subnets=None, vpc_id=None)
Bases:
objectThe VPC configuration for the workforce.
- Parameters:
security_group_ids (
Optional[Sequence[str]]) – The VPC security group IDs.subnets (
Optional[Sequence[str]]) – The VPC subnets.vpc_id (
Optional[str]) – The ID of the VPC.
- See:
- ExampleMetadata:
fixture=_generated
Example:
# The code below shows an example of how to instantiate this type. # The values are placeholders you should change. from aws_cdk import aws_sagemaker as sagemaker workforce_vpc_config_request_property = sagemaker.CfnWorkforce.WorkforceVpcConfigRequestProperty( security_group_ids=["securityGroupIds"], subnets=["subnets"], vpc_id="vpcId" )
Attributes
- security_group_ids
The VPC security group IDs.
- subnets
The VPC subnets.